/* ictest.java */
//#include "mpi.h"
import mpi.*;

//int main( argc, argv )
//     int argc;
//     char **argv;
class ictest {
  static public void main(String[] args) {

  int size, rank, lrank;
  //int key, his_key;
  int key[] = new int[1];
  int his_key[] = new int[1];
  //MPI_Comm myComm;
  //MPI_Comm myFirstComm;
  //MPI_Comm mySecondComm;
  //Comm myComm, myFirstComm, mySecondComm;
  //int errors = 0, sum_errors;
  int errors[] = new int[1]; 
  int sum_errors[] = new int[1]; 
  //MPI_Status status;
  Status status;
  
  /* Initialization */
  //MPI_Init ( &argc, &argv );
  MPI.Init(args);
  //MPI_Comm_rank ( MPI_COMM_WORLD, &rank);
  rank = MPI.COMM_WORLD.Rank();
  //MPI_Comm_size ( MPI_COMM_WORLD, &size);
  size = MPI.COMM_WORLD.Size();


  /* Only works for 2 or more processes */
  if (size >= 2) {
    //MPI_Comm merge1, merge2, merge3, merge4;
    //Comm merge1, merge2, merge3, merge4;

    /* Generate membership key in the range [0,1] */
    key[0] = rank % 2;
    
    //MPI_Comm_split ( MPI_COMM_WORLD, key, rank, &myComm );
    Comm myComm = MPI.COMM_WORLD.Split(key[0], rank);
    //MPI_Intercomm_create (myComm, 0, MPI_COMM_WORLD, (key+1)%2, 1, 
    //                      &myFirstComm );
    Intercomm myFirstComm = MPI.COMM_WORLD.Create_intercomm(myComm, 0,
						       (key[0]+1)%2, 1);
    //MPI_Comm_dup ( myFirstComm, &mySecondComm );
    Comm mySecondComm = myFirstComm.Dup();
    //MPI_Comm_rank( mySecondComm, &lrank );
    lrank = mySecondComm.Rank();
    his_key[0] = -1;
    
    if (lrank == 0) {
      //MPI_Sendrecv (&key,     1, MPI_INT, 0, 0,
      //              &his_key, 1, MPI_INT, 0, 0, mySecondComm, &status);
      mySecondComm.Sendrecv(key,     0, 1, MPI.INT, 0, 0,
			    his_key, 0, 1, MPI.INT, 0, 0);
      if (key[0] != (his_key[0]+1)%2)
        errors[0]++;
    }
    
    if (errors[0] != 0)
      System.out.println("["+rank+"]"+" Failed!");


    boolean high;
    high = (key[0] == 0) ? false : true;
    //MPI_Intercomm_merge ( mySecondComm, key, &merge1 );
    Intracomm merge1 = mySecondComm.Merge(high);
    high = ((key[0]+1)%2 == 0) ? false : true;
    //MPI_Intercomm_merge ( mySecondComm, (key+1)%2, &merge2 );
    Intracomm merge2 = mySecondComm.Merge(high);
    //MPI_Intercomm_merge ( mySecondComm, 0, &merge3 );
    Intracomm merge3 = mySecondComm.Merge(false);
    //MPI_Intercomm_merge ( mySecondComm, 1, &merge4 );
    Intracomm merge4 = mySecondComm.Merge(true);

    /* Free communicators */
    //MPI_Comm_free( &myComm );
    //MPI_Comm_free( &myFirstComm );
    //MPI_Comm_free( &mySecondComm );
    //MPI_Comm_free( &merge1 );
    //MPI_Comm_free( &merge2 );
    //MPI_Comm_free( &merge3 );
    //MPI_Comm_free( &merge4 );
    /*
    myComm.Free();
    myFirstComm.Free();
    mySecondComm.Free();
    merge1.Free();
    merge2.Free();
    merge3.Free();
    merge4.Free();
    */
  }
  else 
    System.out.println
  ("["+rank+"]"+" Failed - at least 2 nodes must be used");

  //MPI_Barrier( MPI_COMM_WORLD );
  MPI.COMM_WORLD.Barrier();
  //MPI_Allreduce( &errors, &sum_errors, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD );
  MPI.COMM_WORLD.Allreduce(errors, 0, sum_errors, 0, 1, MPI.INT, MPI.SUM);  
  if (sum_errors[0] > 0) {
    System.out.println
      ( errors+" errors on process "+rank );
  }
  else if (rank == 0) {
    System.out.println( "Completed successfully" );
  }
  /* Finalize and end! */  
  MPI.Finalize();
  }
}

